module Data.Time.Days where

import Data.Bool
import Data.Time.Calendar
import Data.List as List

type Impair = Int
type Pair   = Int

type Year   = Integer
type Month  = Int

parts :: Year -> Year -> (Double, Double)
parts start end = (fromIntegral is / total, fromIntegral ps / total)
  where
    (is, ps) = counts start end
    total = fromIntegral $ is + ps

counts :: Year -> Year -> (Impair, Pair)
counts start end = (sum is, sum ps)
  where
    (is, ps) = List.unzip $ map count [start..end]


count :: Year -> (Impair, Pair)
count year = (sum is, sum ps)
  where
    (is, ps) = List.unzip $ map countDays $ map (\m -> gregorianMonthLength year m) [1..12]


countDays :: Int -> (Impair, Pair)
countDays n = (n - p, p)
  where
    p = length $ filter (\m -> mod m 2 == 0) [1..n]


